/**
  *  \file int/if/userif.h
  *
  *  (c) 2001-2011 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_INT_IF_USERIF_H
#define PCC_V2_INT_IF_USERIF_H

#include "cpluslib/string.h"
#include "int/keymap.h"
#include "game/coord.h"

class IntValue;

enum IntUserInterfaceProperty {
    iuiScreenNumber,
    iuiScreenRegistered,
    iuiSimFlag,
    iuiScanX,
    iuiScanY,
    iuiChartX,
    iuiChartY
};

class IntUserInterfaceBinding {
    IntUserInterfaceBinding* prev;
    IntUserInterfaceBinding** self;

 protected:
    IntUserInterfaceBinding* getPreviousBinding();
    
 public:
    IntUserInterfaceBinding();
    virtual ~IntUserInterfaceBinding();

    virtual int  getProperty(IntUserInterfaceProperty p) = 0;
    virtual void doGoToScreen(int screen, int obj) = 0;
    virtual void doGoToChart(GPoint pt) = 0;
    virtual void doMoveScanner(GPoint pt) = 0;
    virtual void doPopupConsole() = 0;
    virtual void doOverlayMessage(string_t msg) = 0;
    virtual void doLeaveRace() = 0;
    virtual void doSetChartView(string_t name) = 0;
    virtual IntKeymapRef getKeymap() = 0;

    void setProperty(IntUserInterfaceProperty p, IntValue* v);

    static IntUserInterfaceBinding* getCurrentInstance();
};

#endif
